'** BIOSFONT.BAS
'** Liest Pixelmuster der ASCII-Zeichen aus dem Speicher
'** und schreibt sie im Textmodus vergrert auf den Bildschirm
'** Autor:     Roland Heer
'** Sprache:   Quick Basic
'** Stand:     28.10.96
'** Public Domain
'---------------------------------------------------------------
'$INCLUDE: 'qb.bi'
DEFINT A-Z
DECLARE SUB Pixel (byte, x, y)

DIM Regs AS RegTypeX
Regs.ax = &H1130    'INT 10h: Funktion 11h, Unterfunktion 30h
					'Segment (ES) und Offset (BP) des ersten
					'Zeichens von dem in BH angegebenen BIOS-
					'Font ermitteln
SCREEN 0: CLS

FOR i = 2 TO 7
	Regs.bx = i * 256
	CALL INTERRUPTX(&H10, Regs, Regs)
	offset(i) = Regs.bp         'Offset-Adressen speichern in offset()
NEXT i

start:
INPUT " Font 8*8(1) 8*14(2) 9*14(3) 8*16(4) 9*16(5)   1/2/3/4/5 ? ", font

'zhoehe = Zeichenhhe in Pixeln
'offset = erstes Byte vom Pixelmuster des ersten Zeichens
'a = Abstand bei 9*x-Matrix
'ende = Ende des Zeichensatzes (Anfang des nchsten Fonts)

SELECT CASE font
CASE 0
	SYSTEM
CASE 1
	zhoehe = 8
	offset = offset(3) - 1
	a = 0
	ende = offset(2)
CASE 2
	zhoehe = 14
	offset = offset(2) - 1
	a = 0
	ende = offset(5)
CASE 3
	zhoehe = 15
	offset = offset(5) - 1
	a = 1
	ende = offset(6)
CASE 4
	zhoehe = 16
	offset = offset(6) - 1
	a = 0
	ende = offset(7)
CASE 5
	zhoehe = 17
	offset = offset(7)
	a = 1
	ende = offset(7) + 916
CASE ELSE
	LOCATE 1, 1: PRINT " Falsche Eingabe"; TAB(80);
	GOTO start
END SELECT
zchzhl = 10             'Zahl der gleichzeitig dargestellten Zeichen

'** Die Pixelmuster werden im Feld inbyte() gespeichert

REDIM inbyte(1 TO zhoehe, 1 TO zchzhl)

WIDTH 80, 50
DO
'** Zeichen lesen
	DEF SEG = Regs.es
		FOR j = 1 TO zchzhl
			FOR i = 1 TO zhoehe
				 inbyte(i, j) = PEEK(offset + i + (j - 1) * zhoehe)
			NEXT i
		NEXT j
	DEF SEG
'** Zeichen schreiben
	FOR j = 1 TO zchzhl - a
		FOR i = 1 TO zhoehe - a
			CALL Pixel(inbyte(i + a, j), 7 + (j - 1) * (8 + a), i)
		NEXT i
	NEXT j

	LOCATE 49, 1
	PRINT " Weiter mit beliebiger Taste oder <ESC> fr Abbruch";
	DO: key$ = INKEY$
	LOOP UNTIL LEN(key$)
	IF key$ = CHR$(27) THEN
		WIDTH 80, 25
		SYSTEM
	END IF
	offset = offset + (zchzhl - a) * zhoehe
	IF offset > ende THEN
		WIDTH 80, 25
		GOTO start
	END IF
LOOP
END

SUB Pixel (byte, x, y)
'** Wandelt byte in Binrzahl und setzt entsprechende Zeichen

	FOR i = 0 TO 7
		bit = byte AND 1
		LOCATE y + 1, x + 1 - i
		IF bit THEN PRINT "" ELSE PRINT ""
		byte = byte \ 2
	NEXT i

END SUB

