'** F1130.BAS
'** Demonstriert Interrupt 10h, Funktion 11h, Unterfunktion 30h
'** Quelle:    PC intern
'** Sprache:   Quick Basic
'** Autor:     Roland Heer
'** Stand:     30.10.96
'** Public Domain
'-----------------------------------------------------------
DEFINT A-Z
'$INCLUDE: 'qb.bi'
DIM Regs AS RegTypeX

spalten = 80: zeilen = 25: schirm = 0
WIDTH spalten, zeilen               'oder eine andere Width
SCREEN schirm                       'oder ein anderer Screen

FOR BH = 0 TO 7
	CLS
	READ dt$
	Regs.ax = &H1130
	Regs.bx = BH * 256
	CALL INTERRUPTX(&H10, Regs, Regs)
	PRINT
	PRINT " Interrupt 10h, Funktion 11h, Unterfunktion 30h"
	PRINT " ----------------------------------------------"
	PRINT
	PRINT " Screen:"; schirm
	PRINT " Width :"; spalten; ","; zeilen
	PRINT
	PRINT " Hhe der aktuellen Zeichenmatrix: "; Regs.cx
	PRINT " Anzahl der Zeilen pro Bildschirm: "; (Regs.dx AND &HFF) + 1
	PRINT
	PRINT " BH ="; BH
	PRINT dt$
	PRINT " Segmentadresse des Pointers: "; HEX$(Regs.es)
	PRINT " Offsetadresse des Pointers:  "; HEX$(Regs.bp)
	PRINT
	IF BH < 7 THEN PRINT " Bitte eine Taste drcken"
	SLEEP
NEXT BH
SCREEN 0: WIDTH 80, 25: SYSTEM

DATA " Inhalt des Interrupt-Vektors 1Fh"
DATA " Inhalt des Interrupt-Vektors 43h"
DATA " Adresse der ROM-8*14-Zeichentabelle"
DATA " Adresse der ROM-8*8-Zeichentabelle"
DATA " Adresse der 2. Hlfte der 8*8-Zeichentabelle"
DATA " Adresse der alternativen ROM-9*14-Zeichentabelle"
DATA " Adresse der alternativen ROM-8*16-Zeichentabelle"
DATA " Adresse der alternativen ROM-9*16-Zeichentabelle"

